Subject: Re: [netmod] read-create access

From: Andy Bierman <[email-masked]>
Date: Thu, 02 Oct 2008 08:20:45 -0700

David Reid wrote:
> SMIv2's addition of read-create access was helpful to code generators 
> to know what code to generate to handle a row create attempt. An attempt 
> to create a row in a read-write table generates an error response while an
> attempt to create a row in a read-create table creates a new row (if all 
> the other constraints are met).
> 
> I'd like to automatically generate similar code from yang, but the only
> information I have is config true/false. Is there a way to know if new
> list entries can be created that I'm not seeing? If not, would it be useful 
> to have a substatement under the list statement which would indicate if new 
> list entries can be created? Or maybe extend the config statement in some 
> way?
> 

There have been a few corner cases mentioned for max-access,
and this topic has been discussed several times in the past.

The scope of our problem space is the NETCONF <edit-config>
operation, which has merge, replace, create, and delete.
The config-stmt, mandatory-stmt, and object type (leaf,
list, container, etc.) of the new node and the parent node
are usually enough to determine what to do.

There seems to be at least 3 distinct options not currently supported:

   1) create and delete only (no mgr editing after creation)

   2) merge and replace only on existing nodes
     (no mgr create or delete, just edit)

   3) edit for the startup version only (no affect until next reboot)

I do not think YANG should support this sort of
partial implementation of the <edit-config> operation.
NETCONF conformance means that the agent provides
knobs suited for NETCONF, which have very clear
implementation behavior.

If mandatory is false, then create/delete can be done
at any time by the manager.  If true, the existence of
the parent node (or siblings in a choice) determines
this property.

Any existing config data node can be edited at any time
by the manager (except if locked or access denied).
Any config change must take affect right away for <running>
and at <commit> time for <candidate> as target.

> -David Reid

Andy

_______________________________________________
netmod mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/netmod